dnl Detect XMP environment 
AC_DEFUN([AC_MPI], [
dnl save environment 
mpi_sav_CPPFLAGS="$CPPFLAGS"
mpi_sav_CFLAGS="$CFLAGS"
mpi_sav_LDFLAGS="$LDFALGS"
mpi_sav_LIBS="$LIBS"
AC_LANG_PUSH(C)

ACX_PTHREAD([
  mpi_have_pthread=yes
], [ 
  mpi_have_pthread=no
])
if test "$mpi_have_pthread" = "yes"
then 
  dnl detect binaries application for mpi
  AC_CHECK_PROG(have_mpicc,    [mpicc],    [yes], [no])
  if test "$have_mpicc"  = "yes" 
  then
    HAVE_MPICC=yes
    MPI_CC=`which mpicc`
  fi
  mpi_bin_dir=`dirname $MPI_CC`
  mpi_dir=`dirname $mpi_bin_dir`
  mpi_lib_dir=$mpi_dir"/lib"
  MPI_LIBS="-L$mpi_lib_dir -lmpi -lmpi_cxx"
  MPI_INCLUDES=$mpi_dir"/include"
fi
AC_LANG_POP(C)
CPPFLAGS="$mpi_sav_CPPFLAGS"
CFLAGS="$mpi_sav_CFLAGS"
LDFLAGS="$mpi_sav_LDFLAGS"
LIBS="$mpi_sav_LIBS"
])
