dnl Detect XMP environment 
AC_DEFUN([AC_XMP], [
dnl save environment 
xmp_sav_CPPFLAGS="$CPPFLAGS"
xmp_sav_CFLAGS="$CFLAGS"
xmp_sav_LDFLAGS="$LDFALGS"
xmp_sav_LIBS="$LIBS"
AC_LANG_PUSH(C)

ACX_PTHREAD([
  xmp_have_pthread=yes
], [ 
  xmp_have_pthread=no
])
if test "$xmp_have_pthread" = "yes"
then 
  dnl detect binaries application for xmp 
  AC_CHECK_PROG(have_xmpcc,    [xmpcc],    [yes], [no])
  if test "$have_xmpcc"  = "yes" 
  then
    HAVE_XMPCC=yes
    XMPCC=`which xmpcc`
  fi
  dnl detect xmp prefix 
  if test "$HAVE_XMPCC" = "yes" 
  then 
    xmp_bindir=`dirname $XMPCC`
    xmp_prefix=`dirname $xmp_bindir`
    XMP_DIR=$xmp_prefix
  fi
fi
AC_LANG_POP(C)
CPPFLAGS="$xmp_sav_CPPFLAGS"
CFLAGS="$xmp_sav_CFLAGS"
LDFLAGS="$xmp_sav_LDFLAGS"
LIBS="$xmp_sav_LIBS"
])
